# class Bundler::Dependency

### Constants

PLATFORM_MAP
REVERSE_PLATFORM_MAP

### Attributes

autorequire[R]
gemfile[R]
groups[R]
platforms[R]

### Public Class Methods

new(name, version, options = {}, &blk) click to toggle source
Calls superclass method `Gem::Dependency::new`

    # File lib/bundler/dependency.rb, line 80
    def initialize(name, version, options = {}, &blk)
      type = options["type"] || :runtime
      super(name, version, type)

      @autorequire    = nil
      @groups         = Array(options["group"] || :default).map(&:to_sym)
      @source         = options["source"]
      @platforms      = Array(options["platforms"])
      @env            = options["env"]
      @should_include = options.fetch("should_include", true)
      @gemfile        = options["gemfile"]

      @autorequire = Array(options["require"] || []) if options.key?("require")
    end

### Public Instance Methods

current_env?() click to toggle source

    # File lib/bundler/dependency.rb, line 109
    def current_env?
      return true unless @env
      if @env.is_a?(Hash)
        @env.all? do |key, val|
          ENV[key.to_s] && (val.is_a?(String) ? ENV[key.to_s] == val : ENV[key.to_s] =~ val)
        end
      else
        ENV[@env.to_s]
      end
    end

current_platform?() click to toggle source

    # File lib/bundler/dependency.rb, line 120
    def current_platform?
      return true if @platforms.empty?
      @platforms.any? do |p|
        Bundler.current_ruby.send("#{p}?")
      end
    end

gem_platforms(valid_platforms) click to toggle source

Returns the platforms this dependency is valid for, in the same order as passed in the `valid_platforms` parameter

    # File lib/bundler/dependency.rb, line 97
    def gem_platforms(valid_platforms)
      return valid_platforms if @platforms.empty?

      @gem_platforms ||= @platforms.map {|pl| PLATFORM_MAP[pl] }.compact.uniq

      valid_platforms & @gem_platforms
    end

should_include?() click to toggle source

    # File lib/bundler/dependency.rb, line 105
    def should_include?
      @should_include && current_env? && current_platform?
    end

specific?() click to toggle source
Calls superclass method `Gem::Dependency#specific?`

    # File lib/bundler/dependency.rb, line 133
    def specific?
      super
    rescue NoMethodError
      requirement != ">= 0"
    end

to_lock() click to toggle source
Calls superclass method `Gem::Dependency#to_lock`

    # File lib/bundler/dependency.rb, line 127
    def to_lock
      out = super
      out << "!" if source
      out << "\n"
    end